
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Forecast_scenariosDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const forecast_scenarios = await db.forecast_scenarios.create(
            {
                id: data.id || undefined,
        
        scenario_name: data.scenario_name
        ||
        null
            ,
            
        scenario_type: data.scenario_type
        ||
        null
            ,
            
        revenue_multiplier: data.revenue_multiplier
        ||
        null
            ,
            
        expense_multiplier: data.expense_multiplier
        ||
        null
            ,
            
        cash_buffer_target: data.cash_buffer_target
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        assumptions: data.assumptions
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await forecast_scenarios.setForecast( data.forecast || null, {
            transaction,
        });
        
        await forecast_scenarios.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return forecast_scenarios;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const forecast_scenariosData = data.map((item, index) => ({
                id: item.id || undefined,
                
                scenario_name: item.scenario_name
            ||
            null
            ,
            
                scenario_type: item.scenario_type
            ||
            null
            ,
            
                revenue_multiplier: item.revenue_multiplier
            ||
            null
            ,
            
                expense_multiplier: item.expense_multiplier
            ||
            null
            ,
            
                cash_buffer_target: item.cash_buffer_target
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                assumptions: item.assumptions
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const forecast_scenarios = await db.forecast_scenarios.bulkCreate(forecast_scenariosData, { transaction });

        // For each item created, replace relation files
        

        return forecast_scenarios;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const forecast_scenarios = await db.forecast_scenarios.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.scenario_name !== undefined) updatePayload.scenario_name = data.scenario_name;
        
        
        if (data.scenario_type !== undefined) updatePayload.scenario_type = data.scenario_type;
        
        
        if (data.revenue_multiplier !== undefined) updatePayload.revenue_multiplier = data.revenue_multiplier;
        
        
        if (data.expense_multiplier !== undefined) updatePayload.expense_multiplier = data.expense_multiplier;
        
        
        if (data.cash_buffer_target !== undefined) updatePayload.cash_buffer_target = data.cash_buffer_target;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.assumptions !== undefined) updatePayload.assumptions = data.assumptions;
        
        
        updatePayload.updatedById = currentUser.id;

        await forecast_scenarios.update(updatePayload, {transaction});

        
        
        if (data.forecast !== undefined) {
            await forecast_scenarios.setForecast(
              
              data.forecast,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await forecast_scenarios.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return forecast_scenarios;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const forecast_scenarios = await db.forecast_scenarios.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of forecast_scenarios) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of forecast_scenarios) {
                await record.destroy({transaction});
            }
        });


        return forecast_scenarios;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const forecast_scenarios = await db.forecast_scenarios.findByPk(id, options);

        await forecast_scenarios.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await forecast_scenarios.destroy({
            transaction
        });

        return forecast_scenarios;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const forecast_scenarios = await db.forecast_scenarios.findOne(
            { where },
            { transaction },
        );

        if (!forecast_scenarios) {
            return forecast_scenarios;
        }

        const output = forecast_scenarios.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.forecast = await forecast_scenarios.getForecast({
            transaction
        });
        
        
        output.organizations = await forecast_scenarios.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.forecasts,
        as: 'forecast',
        
        where: filter.forecast ? {
          [Op.or]: [
            { id: { [Op.in]: filter.forecast.split('|').map(term => Utils.uuid(term)) } },
            {
              forecast_name: {
                [Op.or]: filter.forecast.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.scenario_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'forecast_scenarios',
                        'scenario_name',
                        filter.scenario_name,
                    ),
                };
            }
            
            if (filter.assumptions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'forecast_scenarios',
                        'assumptions',
                        filter.assumptions,
                    ),
                };
            }
            

            
            

            
            if (filter.revenue_multiplierRange) {
                const [start, end] = filter.revenue_multiplierRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    revenue_multiplier: {
                    ...where.revenue_multiplier,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    revenue_multiplier: {
                    ...where.revenue_multiplier,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expense_multiplierRange) {
                const [start, end] = filter.expense_multiplierRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expense_multiplier: {
                    ...where.expense_multiplier,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expense_multiplier: {
                    ...where.expense_multiplier,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cash_buffer_targetRange) {
                const [start, end] = filter.cash_buffer_targetRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cash_buffer_target: {
                    ...where.cash_buffer_target,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cash_buffer_target: {
                    ...where.cash_buffer_target,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.scenario_type) {
                where = {
                    ...where,
                scenario_type: filter.scenario_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.forecast_scenarios.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'forecast_scenarios',
                        'scenario_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.forecast_scenarios.findAll({
            attributes: [ 'id', 'scenario_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['scenario_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.scenario_name,
        }));
    }

    
};

